
_Wtv020_Init:

;LettoreAD4WTV020Prima.mbas,30 :: 		sub procedure Wtv020_Init()
;LettoreAD4WTV020Prima.mbas,31 :: 		ADCON0=0                'ATTIVA IL CONVERTITORE ANALOGICO DIGITALE
	CLRF       ADCON0+0
;LettoreAD4WTV020Prima.mbas,32 :: 		ANSEL=0                 ' CONFIGURA TUTTI I PIN ANALOGICI COME DIGITALI
	CLRF       ANSEL+0
;LettoreAD4WTV020Prima.mbas,33 :: 		CMCON=0x07              ' SPEGNE IL COMPARATORE
	MOVLW      7
	MOVWF      CMCON+0
;LettoreAD4WTV020Prima.mbas,34 :: 		porta=0
	CLRF       PORTA+0
;LettoreAD4WTV020Prima.mbas,35 :: 		portb=0
	CLRF       PORTB+0
;LettoreAD4WTV020Prima.mbas,40 :: 		WTV020_CL_Direction=0   ' set line as output
	BCF        TRISA2_bit+0, BitPos(TRISA2_bit+0)
;LettoreAD4WTV020Prima.mbas,41 :: 		WTV020_DA_Direction=0   ' set line as output
	BCF        TRISA3_bit+0, BitPos(TRISA3_bit+0)
;LettoreAD4WTV020Prima.mbas,42 :: 		WTV020_RS_Direction=0   ' set line as output
	BCF        TRISA1_bit+0, BitPos(TRISA1_bit+0)
;LettoreAD4WTV020Prima.mbas,43 :: 		WTV020_BS_Direction=1   ' set line as input
	BSF        TRISA4_bit+0, BitPos(TRISA4_bit+0)
;LettoreAD4WTV020Prima.mbas,45 :: 		WTV020_RS=1
	BSF        RA1_bit+0, BitPos(RA1_bit+0)
;LettoreAD4WTV020Prima.mbas,47 :: 		WTV020_RS=0
	BCF        RA1_bit+0, BitPos(RA1_bit+0)
;LettoreAD4WTV020Prima.mbas,48 :: 		delay_ms(5)  ' Reset cicle 5ms
	MOVLW      7
	MOVWF      R12+0
	MOVLW      125
	MOVWF      R13+0
L__Wtv020_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Wtv020_Init1
;LettoreAD4WTV020Prima.mbas,49 :: 		WTV020_RS=1
	BSF        RA1_bit+0, BitPos(RA1_bit+0)
;LettoreAD4WTV020Prima.mbas,51 :: 		WTV020_CL=1  ' delay between RS=Higt and CL=Low
	BSF        RA2_bit+0, BitPos(RA2_bit+0)
;LettoreAD4WTV020Prima.mbas,52 :: 		delay_ms(300)
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L__Wtv020_Init2:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_Init2
	DECFSZ     R12+0, 1
	GOTO       L__Wtv020_Init2
	DECFSZ     R11+0, 1
	GOTO       L__Wtv020_Init2
;LettoreAD4WTV020Prima.mbas,53 :: 		end Sub
L_end_Wtv020_Init:
	RETURN
; end of _Wtv020_Init

_Wtv020_SendCommand:

;LettoreAD4WTV020Prima.mbas,57 :: 		dim mask as byte
;LettoreAD4WTV020Prima.mbas,59 :: 		WTV020_CL=0                      'clock low level pulse
	BCF        RA2_bit+0, BitPos(RA2_bit+0)
;LettoreAD4WTV020Prima.mbas,60 :: 		delay_us(1000)                   'initial delay before data Trasmit
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L__Wtv020_SendCommand4:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_SendCommand4
	DECFSZ     R12+0, 1
	GOTO       L__Wtv020_SendCommand4
;LettoreAD4WTV020Prima.mbas,62 :: 		for mask=15 to 0 step -1
	MOVLW      15
	MOVWF      R4+0
L__Wtv020_SendCommand6:
;LettoreAD4WTV020Prima.mbas,64 :: 		if ((commando>>mask) and %0001>0) then
	MOVF       R4+0, 0
	MOVWF      R2+0
	MOVF       FARG_Wtv020_SendCommand_commando+0, 0
	MOVWF      R0+0
	MOVF       FARG_Wtv020_SendCommand_commando+1, 0
	MOVWF      R0+1
	MOVF       R2+0, 0
L__Wtv020_SendCommand47:
	BTFSC      STATUS+0, 2
	GOTO       L__Wtv020_SendCommand48
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+1, 7
	ADDLW      255
	GOTO       L__Wtv020_SendCommand47
L__Wtv020_SendCommand48:
	MOVLW      1
	ANDWF      R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	MOVWF      R2+1
	MOVLW      0
	ANDWF      R2+1, 1
	MOVF       R2+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Wtv020_SendCommand49
	MOVF       R2+0, 0
	SUBLW      0
L__Wtv020_SendCommand49:
	BTFSC      STATUS+0, 0
	GOTO       L__Wtv020_SendCommand11
;LettoreAD4WTV020Prima.mbas,65 :: 		WTV020_DA=1
	BSF        RA3_bit+0, BitPos(RA3_bit+0)
	GOTO       L__Wtv020_SendCommand12
;LettoreAD4WTV020Prima.mbas,66 :: 		else
L__Wtv020_SendCommand11:
;LettoreAD4WTV020Prima.mbas,67 :: 		WTV020_DA=0
	BCF        RA3_bit+0, BitPos(RA3_bit+0)
;LettoreAD4WTV020Prima.mbas,68 :: 		end if
L__Wtv020_SendCommand12:
;LettoreAD4WTV020Prima.mbas,72 :: 		delay_us(666)                    '1 clock-timing-Step  (and not 50us)
	MOVLW      221
	MOVWF      R13+0
L__Wtv020_SendCommand13:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_SendCommand13
	NOP
	NOP
;LettoreAD4WTV020Prima.mbas,73 :: 		WTV020_CL=1                     'clock high level pulse
	BSF        RA2_bit+0, BitPos(RA2_bit+0)
;LettoreAD4WTV020Prima.mbas,74 :: 		delay_us(666)                    '2 clock-timing-Step  (and not 50us)
	MOVLW      221
	MOVWF      R13+0
L__Wtv020_SendCommand14:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_SendCommand14
	NOP
	NOP
;LettoreAD4WTV020Prima.mbas,75 :: 		if (mask>0) then WTV020_DA=0    'set data pin to low (till last bit)
	MOVF       R4+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__Wtv020_SendCommand16
	BCF        RA3_bit+0, BitPos(RA3_bit+0)
	GOTO       L__Wtv020_SendCommand17
;LettoreAD4WTV020Prima.mbas,76 :: 		else WTV020_DA=1 end if
L__Wtv020_SendCommand16:
	BSF        RA3_bit+0, BitPos(RA3_bit+0)
L__Wtv020_SendCommand17:
;LettoreAD4WTV020Prima.mbas,77 :: 		delay_us(666)                    '3 clock-timing-Step  (and not 50us)
	MOVLW      221
	MOVWF      R13+0
L__Wtv020_SendCommand18:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_SendCommand18
	NOP
	NOP
;LettoreAD4WTV020Prima.mbas,78 :: 		if (mask>0) then WTV020_CL=0    'clock low level pulse (till last bit)
	MOVF       R4+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__Wtv020_SendCommand20
	BCF        RA2_bit+0, BitPos(RA2_bit+0)
	GOTO       L__Wtv020_SendCommand21
;LettoreAD4WTV020Prima.mbas,79 :: 		else WTV020_CL=1
L__Wtv020_SendCommand20:
	BSF        RA2_bit+0, BitPos(RA2_bit+0)
;LettoreAD4WTV020Prima.mbas,80 :: 		end if
L__Wtv020_SendCommand21:
;LettoreAD4WTV020Prima.mbas,81 :: 		next mask
	MOVF       R4+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Wtv020_SendCommand9
	MOVLW      255
	ADDWF      R4+0, 1
	GOTO       L__Wtv020_SendCommand6
L__Wtv020_SendCommand9:
;LettoreAD4WTV020Prima.mbas,83 :: 		delay_ms(1000)    ' wait 1sec before send other command (it's more stable)
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L__Wtv020_SendCommand22:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_SendCommand22
	DECFSZ     R12+0, 1
	GOTO       L__Wtv020_SendCommand22
	DECFSZ     R11+0, 1
	GOTO       L__Wtv020_SendCommand22
	NOP
	NOP
;LettoreAD4WTV020Prima.mbas,84 :: 		end sub
L_end_Wtv020_SendCommand:
	RETURN
; end of _Wtv020_SendCommand

_Wtv020_Play:

;LettoreAD4WTV020Prima.mbas,87 :: 		sub procedure Wtv020_Play(dim voiceNumber as word)
;LettoreAD4WTV020Prima.mbas,88 :: 		Wtv020_SendCommand(voiceNumber)
	MOVF       FARG_Wtv020_Play_voiceNumber+0, 0
	MOVWF      FARG_Wtv020_SendCommand_commando+0
	MOVF       FARG_Wtv020_Play_voiceNumber+1, 0
	MOVWF      FARG_Wtv020_SendCommand_commando+1
	CALL       _Wtv020_SendCommand+0
;LettoreAD4WTV020Prima.mbas,90 :: 		delay_ms(20)
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L__Wtv020_Play24:
	DECFSZ     R13+0, 1
	GOTO       L__Wtv020_Play24
	DECFSZ     R12+0, 1
	GOTO       L__Wtv020_Play24
	NOP
;LettoreAD4WTV020Prima.mbas,92 :: 		while(WTV020_BS)
L__Wtv020_Play26:
	BTFSC      RA4_bit+0, BitPos(RA4_bit+0)
	GOTO       L__Wtv020_Play26
;LettoreAD4WTV020Prima.mbas,94 :: 		end sub
L_end_Wtv020_Play:
	RETURN
; end of _Wtv020_Play

_Wtv020_AsyncPlay:

;LettoreAD4WTV020Prima.mbas,97 :: 		sub procedure Wtv020_AsyncPlay(dim voiceNumber as word)
;LettoreAD4WTV020Prima.mbas,98 :: 		Wtv020_SendCommand(voiceNumber)
	MOVF       FARG_Wtv020_AsyncPlay_voiceNumber+0, 0
	MOVWF      FARG_Wtv020_SendCommand_commando+0
	MOVF       FARG_Wtv020_AsyncPlay_voiceNumber+1, 0
	MOVWF      FARG_Wtv020_SendCommand_commando+1
	CALL       _Wtv020_SendCommand+0
;LettoreAD4WTV020Prima.mbas,99 :: 		end sub
L_end_Wtv020_AsyncPlay:
	RETURN
; end of _Wtv020_AsyncPlay

_Wtv020_Stop:

;LettoreAD4WTV020Prima.mbas,102 :: 		sub procedure Wtv020_Stop()
;LettoreAD4WTV020Prima.mbas,103 :: 		Wtv020_SendCommand(_STOP)
	MOVLW      255
	MOVWF      FARG_Wtv020_SendCommand_commando+0
	MOVLW      255
	MOVWF      FARG_Wtv020_SendCommand_commando+1
	CALL       _Wtv020_SendCommand+0
;LettoreAD4WTV020Prima.mbas,104 :: 		end sub
L_end_Wtv020_Stop:
	RETURN
; end of _Wtv020_Stop

_Wtv020_Pause:

;LettoreAD4WTV020Prima.mbas,107 :: 		sub procedure Wtv020_Pause()
;LettoreAD4WTV020Prima.mbas,108 :: 		Wtv020_SendCommand(_PLAY_PAUSE)
	MOVLW      254
	MOVWF      FARG_Wtv020_SendCommand_commando+0
	MOVLW      255
	MOVWF      FARG_Wtv020_SendCommand_commando+1
	CALL       _Wtv020_SendCommand+0
;LettoreAD4WTV020Prima.mbas,109 :: 		end sub
L_end_Wtv020_Pause:
	RETURN
; end of _Wtv020_Pause

_Wtv020_Mute:

;LettoreAD4WTV020Prima.mbas,112 :: 		sub procedure Wtv020_Mute()
;LettoreAD4WTV020Prima.mbas,113 :: 		Wtv020_SendCommand(_VOLUME_MIN)
	MOVLW      240
	MOVWF      FARG_Wtv020_SendCommand_commando+0
	MOVLW      255
	MOVWF      FARG_Wtv020_SendCommand_commando+1
	CALL       _Wtv020_SendCommand+0
;LettoreAD4WTV020Prima.mbas,114 :: 		end sub
L_end_Wtv020_Mute:
	RETURN
; end of _Wtv020_Mute

_Wtv020_Volume:

;LettoreAD4WTV020Prima.mbas,117 :: 		sub procedure Wtv020_Volume(dim volume as word)
;LettoreAD4WTV020Prima.mbas,120 :: 		if volume<$FFF8 then Wtv020_SendCommand(volume)
	MOVLW      255
	SUBWF      FARG_Wtv020_Volume_volume+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Wtv020_Volume56
	MOVLW      248
	SUBWF      FARG_Wtv020_Volume_volume+0, 0
L__Wtv020_Volume56:
	BTFSC      STATUS+0, 0
	GOTO       L__Wtv020_Volume36
	MOVF       FARG_Wtv020_Volume_volume+0, 0
	MOVWF      FARG_Wtv020_SendCommand_commando+0
	MOVF       FARG_Wtv020_Volume_volume+1, 0
	MOVWF      FARG_Wtv020_SendCommand_commando+1
	CALL       _Wtv020_SendCommand+0
	GOTO       L__Wtv020_Volume37
;LettoreAD4WTV020Prima.mbas,121 :: 		else Wtv020_SendCommand(_VOLUME_MAX)
L__Wtv020_Volume36:
	MOVLW      247
	MOVWF      FARG_Wtv020_SendCommand_commando+0
	MOVLW      255
	MOVWF      FARG_Wtv020_SendCommand_commando+1
	CALL       _Wtv020_SendCommand+0
;LettoreAD4WTV020Prima.mbas,122 :: 		end if
L__Wtv020_Volume37:
;LettoreAD4WTV020Prima.mbas,123 :: 		end sub
L_end_Wtv020_Volume:
	RETURN
; end of _Wtv020_Volume

_main:

;LettoreAD4WTV020Prima.mbas,130 :: 		dim i as word
;LettoreAD4WTV020Prima.mbas,131 :: 		Wtv020_Init
	CALL       _Wtv020_Init+0
;LettoreAD4WTV020Prima.mbas,133 :: 		for i=0 to 7                    ' In the Micro-SD there's 6 Songs
	CLRF       main_i+0
	CLRF       main_i+1
L__main40:
;LettoreAD4WTV020Prima.mbas,134 :: 		Wtv020_AsyncPlay($0000 + i)   'After sended play-Play-command you need to
	MOVF       main_i+0, 0
	MOVWF      FARG_Wtv020_AsyncPlay_voiceNumber+0
	MOVF       main_i+1, 0
	MOVWF      FARG_Wtv020_AsyncPlay_voiceNumber+1
	CALL       _Wtv020_AsyncPlay+0
;LettoreAD4WTV020Prima.mbas,135 :: 		Wtv020_Volume($FFF5)          'send the Volume-Control-Command or else the
	MOVLW      245
	MOVWF      FARG_Wtv020_Volume_volume+0
	MOVLW      255
	MOVWF      FARG_Wtv020_Volume_volume+1
	CALL       _Wtv020_Volume+0
;LettoreAD4WTV020Prima.mbas,136 :: 		delay_ms(6000)                'sound module not support the full Volume.
	MOVLW      31
	MOVWF      R11+0
	MOVLW      113
	MOVWF      R12+0
	MOVLW      30
	MOVWF      R13+0
L__main44:
	DECFSZ     R13+0, 1
	GOTO       L__main44
	DECFSZ     R12+0, 1
	GOTO       L__main44
	DECFSZ     R11+0, 1
	GOTO       L__main44
	NOP
;LettoreAD4WTV020Prima.mbas,137 :: 		next i
	MOVLW      0
	XORWF      main_i+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main58
	MOVLW      7
	XORWF      main_i+0, 0
L__main58:
	BTFSC      STATUS+0, 2
	GOTO       L__main43
	INCF       main_i+0, 1
	BTFSC      STATUS+0, 2
	INCF       main_i+1, 1
	GOTO       L__main40
L__main43:
L_end_main:
	GOTO       $+0
; end of _main
